1.安装编译环境包(防止出现安装错误)

yum install gcc-c++ gcc make cmake zlib-devel bzip2-devel openssl-devel ncurse-devel -y

2.在线下载Python3.7源码包

#进入tmp目录
cd /data/src/
#下载python3.7.0
wget https://www.python.org/ftp/python/3.6.6/Python-3.6.6.tgz

3.解压并配置

#解压
tar zxvf Python-3.6.6.tgz
#进入python3.7.0目录
cd Python-3.7.0
#创建目录
mkdir /data/apps/python3 -p
#配置(指定安装目录)
./configure --prefix=/data/apps/python3 --enable-optimizations 

支持ssl 配置

#http://blog.51cto.com/13160495/2093863
#修改Setup文件
vi /root/Python-3.6.5/Modules/Setup.dist
#修改结果如下:
# Socket module helper for socket(2)
_socket socketmodule.c timemodule.c

# Socket module helper for SSL support; you must comment out the other
# socket line above, and possibly edit the SSL variable:
SSL=/usr/local/ssl
_ssl _ssl.c \
-DUSE_SSL -I$(SSL)/include -I$(SSL)/include/openssl \
-L$(SSL)/lib -lssl -lcrypto

编译及安装

#编译及安装
make && make install
#更换系统默认Python版本
#备份原系统旧版本python
mv /usr/bin/python /usr/bin/python.bak
ln -s  /data/apps/python3/bin/python3.6 /usr/bin/python  
ln -s  /data/apps/python3/bin/pip3.6   /usr/bin/pip

修改yum功能

因为yum的功能依赖Pyhon2,现在更改默认Python版本后会导致yum无法正常工作,所以进行以下修复

vi /usr/bin/yum
#打开文件后,修改第一行为:
#!/usr/bin/python2.7

修正 yum 链接,修改文件 /usr/libexec/urlgrabber-ext-down,指定python版本为系统自带版本

#! /usr/bin/python 修改为 #! /usr/bin/python2.7

#ubuntu 安装python3

1.安装python3

apt-get install python3

2.安装pip3

apt-get install python3-pip

3.为python3添加包

pip3 install packagename
文档更新时间: 2019-06-14 11:05   作者:月影鹏鹏